JUCE: AudioSubsectionReader Class Reference

JUCE

Public Member Functions | List of all members
AudioSubsectionReader Class Reference
juce_audio_formats » format

This class is used to wrap an AudioFormatReader and only read from a subsection of the file. More...

`#include <juce_AudioSubsectionReader.h>`

Inheritance diagram for AudioSubsectionReader:

## Public Member Functions
| AudioSubsectionReader (AudioFormatReader *sourceReader, int64 subsectionStartSample, int64 subsectionLength, bool deleteSourceWhenDeleted)
| Creates an AudioSubsectionReader for a given data source. More...
| ~AudioSubsectionReader () override
| Destructor. More...
bool | readSamples (int **destSamples, int numDestChannels, int startOffsetInDestBuffer, int64 startSampleInFile, int numSamples) override
| Subclasses must implement this method to perform the low-level read operation. More...
void | readMaxLevels (int64 startSample, int64 numSamples, Range< float > *results, int numChannelsToRead) override
| Finds the highest and lowest sample levels from a section of the audio stream. More...
virtual void | readMaxLevels (int64 startSample, int64 numSamples, Range< float > *results, int numChannelsToRead)
| Finds the highest and lowest sample levels from a section of the audio stream. More...
virtual void | readMaxLevels (int64 startSample, int64 numSamples, float &lowestLeft, float &highestLeft, float &lowestRight, float &highestRight)
| Finds the highest and lowest sample levels from a section of the audio stream. More...
Public Member Functions inherited from AudioFormatReader
virtual | ~AudioFormatReader ()
| Destructor. More...
const String & | getFormatName () const noexcept
| Returns a description of what type of format this is. More...
bool | read (float *const *destChannels, int numDestChannels, int64 startSampleInSource, int numSamplesToRead)
| Reads samples from the stream. More...
bool | read (int *const *destChannels, int numDestChannels, int64 startSampleInSource, int numSamplesToRead, bool fillLeftoverChannelsWithCopies)
| Reads samples from the stream. More...
bool | read (AudioBuffer< float > *buffer, int startSampleInDestBuffer, int numSamples, int64 readerStartSample, bool useReaderLeftChan, bool useReaderRightChan)
| Fills a section of an AudioBuffer from this reader. More...
virtual void | readMaxLevels (int64 startSample, int64 numSamples, Range< float > *results, int numChannelsToRead)
| Finds the highest and lowest sample levels from a section of the audio stream. More...
virtual void | readMaxLevels (int64 startSample, int64 numSamples, float &lowestLeft, float &highestLeft, float &lowestRight, float &highestRight)
| Finds the highest and lowest sample levels from a section of the audio stream. More...
int64 | searchForLevel (int64 startSample, int64 numSamplesToSearch, double magnitudeRangeMinimum, double magnitudeRangeMaximum, int minimumConsecutiveSamples)
| Scans the source looking for a sample whose magnitude is in a specified range. More...
virtual AudioChannelSet | getChannelLayout ()
| Get the channel layout of the audio stream. More...
virtual bool | readSamples (int **destChannels, int numDestChannels, int startOffsetInDestBuffer, int64 startSampleInFile, int numSamples)=0
| Subclasses must implement this method to perform the low-level read operation. More...

## Additional Inherited Members
Public Attributes inherited from AudioFormatReader
double | sampleRate = 0
| The sample-rate of the stream. More...
unsigned int | bitsPerSample = 0
| The number of bits per sample, e.g. More...
int64 | lengthInSamples = 0
| The total number of samples in the audio stream. More...
unsigned int | numChannels = 0
| The total number of channels in the audio stream. More...
bool | usesFloatingPointData = false
| Indicates whether the data is floating-point or fixed. More...
StringPairArray | metadataValues
| A set of metadata values that the reader has pulled out of the stream. More...
InputStream * | input
| The input stream, for use by subclasses. More...
Protected Member Functions inherited from AudioFormatReader
| AudioFormatReader (InputStream *sourceStream, const String &formatName)
| Creates an AudioFormatReader object. More...
Static Protected Member Functions inherited from AudioFormatReader
static void | clearSamplesBeyondAvailableLength (int **destChannels, int numDestChannels, int startOffsetInDestBuffer, int64 startSampleInFile, int &numSamples, int64 fileLengthInSamples)
| Used by AudioFormatReader subclasses to clear any parts of the data blocks that lie beyond the end of their available length. More...

## Detailed Description

This class is used to wrap an AudioFormatReader and only read from a subsection of the file.

So if you have a reader which can read a 1000 sample file, you could wrap it in one of these to only access, e.g. samples 100 to 200, and any samples outside that will come back as 0. Accessing sample 0 from this reader will actually read the first sample from the other's subsection, which might be at a non-zero position.

See also
  AudioFormatReader

## Constructor & Destructor Documentation

## ◆ AudioSubsectionReader()

AudioSubsectionReader::AudioSubsectionReader | ( | AudioFormatReader * | sourceReader,
|  | int64 | subsectionStartSample,
|  | int64 | subsectionLength,
|  | bool | deleteSourceWhenDeleted
| ) |  |

Creates an AudioSubsectionReader for a given data source.

Parameters

  sourceReader | the source reader from which we'll be taking data
  subsectionStartSample | the sample within the source reader which will be mapped onto sample 0 for this reader.
  subsectionLength | the number of samples from the source that will make up the subsection. If this reader is asked for any samples beyond this region, it will return zero.
  deleteSourceWhenDeleted | if true, the sourceReader object will be deleted when this object is deleted.

## ◆ ~AudioSubsectionReader()

AudioSubsectionReader::~AudioSubsectionReader | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ readSamples()

bool AudioSubsectionReader::readSamples | ( | int ** | destChannels,
|  | int | numDestChannels,
|  | int | startOffsetInDestBuffer,
|  | int64 | startSampleInFile,
|  | int | numSamples
| ) |  |
| overridevirtual

Subclasses must implement this method to perform the low-level read operation.

Callers should use read() instead of calling this directly.

Parameters

  destChannels | the array of destination buffers to fill. Some of these pointers may be null
  numDestChannels | the number of items in the destChannels array. This value is guaranteed not to be greater than the number of channels that this reader object contains
  startOffsetInDestBuffer | the number of samples from the start of the dest data at which to begin writing
  startSampleInFile | the number of samples into the source data at which to begin reading. This value is guaranteed to be >= 0.
  numSamples | the number of samples to read

Implements AudioFormatReader.

## ◆ readMaxLevels() [1/3]

void AudioSubsectionReader::readMaxLevels | ( | int64 | startSample,
|  | int64 | numSamples,
|  | Range< float > * | results,
|  | int | numChannelsToRead
| ) |  |
| overridevirtual

Finds the highest and lowest sample levels from a section of the audio stream.

This will read a block of samples from the stream, and measure the highest and lowest sample levels from the channels in that section, returning these as normalised floating-point levels.

Parameters

  startSample | the offset into the audio stream to start reading from. It's ok for this to be beyond the start or end of the stream.
  numSamples | how many samples to read
  results | this array will be filled with Range values for each channel. The array must contain numChannels elements.
  numChannelsToRead | the number of channels of data to scan. This must be more than zero, but not more than the total number of channels that the reader contains

See also
  read

Reimplemented from AudioFormatReader.

## ◆ readMaxLevels() [2/3]

virtual void AudioFormatReader::readMaxLevels | ( | int64 | startSample,
|  | int64 | numSamples,
|  | Range< float > * | results,
|  | int | numChannelsToRead
| ) |  |
| virtual

Finds the highest and lowest sample levels from a section of the audio stream.

This will read a block of samples from the stream, and measure the highest and lowest sample levels from the channels in that section, returning these as normalised floating-point levels.

Parameters

  startSample | the offset into the audio stream to start reading from. It's ok for this to be beyond the start or end of the stream.
  numSamples | how many samples to read
  results | this array will be filled with Range values for each channel. The array must contain numChannels elements.
  numChannelsToRead | the number of channels of data to scan. This must be more than zero, but not more than the total number of channels that the reader contains

See also
  read

Reimplemented from AudioFormatReader.

## ◆ readMaxLevels() [3/3]

virtual void AudioFormatReader::readMaxLevels | ( | int64 | startSample,
|  | int64 | numSamples,
|  | float & | lowestLeft,
|  | float & | highestLeft,
|  | float & | lowestRight,
|  | float & | highestRight
| ) |  |
| virtual

Finds the highest and lowest sample levels from a section of the audio stream.

This will read a block of samples from the stream, and measure the highest and lowest sample levels from the channels in that section, returning these as normalised floating-point levels.

Parameters

  startSample | the offset into the audio stream to start reading from. It's ok for this to be beyond the start or end of the stream.
  numSamples | how many samples to read
  lowestLeft | on return, this is the lowest absolute sample from the left channel
  highestLeft | on return, this is the highest absolute sample from the left channel
  lowestRight | on return, this is the lowest absolute sample from the right channel (if there is one)
  highestRight | on return, this is the highest absolute sample from the right channel (if there is one)

See also
  read

Reimplemented from AudioFormatReader.

The documentation for this class was generated from the following file:

- juce_AudioSubsectionReader.h